summarylogtreecommitdiffstats
path: root/postgresql-check-db-dir
diff options
context:
space:
mode:
authorbanzay2017-10-09 01:18:47 +0300
committerbanzay2017-10-09 01:18:47 +0300
commitf002a0e2dfb2ec7bcd992440b47dc1af1d2f832e (patch)
treeda923a50484870971a2f2966f122efa34f6e389b /postgresql-check-db-dir
parentda68a5ca3893c50fdcdb9b073a1f223affd03964 (diff)
downloadaur-f002a0e2dfb2ec7bcd992440b47dc1af1d2f832e.tar.gz
package update
Diffstat (limited to 'postgresql-check-db-dir')
-rw-r--r--postgresql-check-db-dir49
1 files changed, 49 insertions, 0 deletions
diff --git a/postgresql-check-db-dir b/postgresql-check-db-dir
new file mode 100644
index 000000000000..aa51d7643535
--- /dev/null
+++ b/postgresql-check-db-dir
@@ -0,0 +1,49 @@
+#!/bin/sh
+
+# This script verifies that the postgresql data directory has been correctly
+# initialized. We do not want to automatically initdb it, because that has
+# a risk of catastrophic failure (ie, overwriting a valuable database) in
+# corner cases, such as a remotely mounted database on a volume that's a
+# bit slow to mount. But we can at least emit a message advising newbies
+# what to do.
+
+PGDATA="$1"
+
+if [ -z "$PGDATA" ]
+then
+ echo "Usage: $0 database-path"
+ exit 1
+fi
+
+# PGMAJORVERSION is major version
+PGMAJORVERSION=9.6
+# PREVMAJORVERSION is the previous major version
+PREVMAJORVERSION=9.5
+
+# Check for the PGDATA structure
+if [ -f "$PGDATA/PG_VERSION" ] && [ -d "$PGDATA/base" ]
+then
+ # Check version of existing PGDATA
+ if [ x`cat "$PGDATA/PG_VERSION"` = x"$PGMAJORVERSION" ]
+ then
+ : A-OK
+ elif [ x`cat "$PGDATA/PG_VERSION"` = x"$PREVMAJORVERSION" ]
+ then
+ echo $"An old version of the database format was found."
+ echo $"See https://wiki.archlinux.org/index.php/PostgreSQL#Upgrading_PostgreSQL"
+ exit 1
+ else
+ echo $"An old version of the database format was found."
+ echo $"You need to dump and reload before using PostgreSQL $PGMAJORVERSION."
+ echo $"See http://www.postgresql.org/docs/$PGMAJORVERSION/static/upgrading.html"
+ exit 1
+ fi
+else
+ # No existing PGDATA! Warn the user to initdb it.
+ echo $"\"$PGDATA\" is missing or empty. Use a command like"
+ echo $" su - postgres -c \"initdb --locale en_US.UTF-8 -D '$PGDATA'\""
+ echo $"with relevant options, to initialize the database cluster."
+ exit 1
+fi
+
+exit 0